#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <math.h>

#define ERROR(x) { perror(x); exit(1); }
/* #define SERVERADDR (u_long)0x7f000001 */ 
/* #define SERVERADDR (u_long)0x869b4101   rafiki.informatik.uni-mannheim.de */
#define MESSAGE quit
short PORT = 7777;


 u_long SERVERADDR;  

static char buf[BUFSIZ];

u_long stoip (char string[])
{
  int i,n,stringlen,a[4],temp;
  u_long addr=0;
  for (i=0;i<=3;i++) a[i]=0;
  i=0;while ((int)string[i]!=0) i=i+1;

  stringlen = i-1;
  i = 0;
  if (stringlen>=15) return (-1);
  
  while (stringlen>=0)
    {
      if (i>3) return (-1);
      n=0;
      while (string[stringlen]!='.' && stringlen >=0)
	{
	  temp = (int)string[stringlen]-48;
	  if (string[stringlen]!='.')
	    {
	      if (temp <0 ) return (-1);
	      if (temp >9 ) return (-1);
	    }
	  a[i]+=temp*(int)pow (10,n) ;
	  stringlen--;n++;
	}
      if (a[i]>255) return(-1);
      stringlen--;
      i++;
    }
  if (i!=4) return (-1);
  for (i=0;i<=3;i++) addr+=(a[i]*pow(2,(i*8)));
  return (addr);
}
  

int main(int argc, char *argv[]) {
  int orig_sock, new_sock, serv_len;
  struct sockaddr_in clnt_adr, serv_adr;
 
  int len,offset,i,count;

  
  if (argc == 1) 
    {
      printf("Usage: client IP-ADRESSE [PORT]\n");exit(1);
    }
  else
    
    {
      printf("Server IP: %s \n",argv[1]);
      if (argc >= 3) 
	{
	  offset = atoi(argv[2]);
	 
	  PORT += offset;
	}
    }

  printf ("PORT: %d\n",PORT);
  if ((SERVERADDR = stoip (argv[1]))==-1) {printf("IP fehlerhaft!\n");exit (1);}
  printf ("SERVERADDR: %x\n",SERVERADDR);
  printf("Die Buffersize betraegt auf diesem System: %d\n",BUFSIZ);
  
  if ((orig_sock = socket(AF_INET,SOCK_STREAM, 0))<0) ERROR("socket");

  memset(&serv_adr, 0, sizeof(serv_adr));
  serv_adr.sin_family = AF_INET;

  serv_adr.sin_addr.s_addr = htonl(SERVERADDR);
  serv_adr.sin_port = htons(PORT);
  serv_len = sizeof(serv_adr);
  if (connect (orig_sock,(struct sockaddr *)&serv_adr,serv_len) < 0) ERROR ("connect");
  printf("Connected.\n");

  do
	{
	  memset(buf,0,BUFSIZ);
	  printf("Eingabe:");
	  gets (buf);
	  printf("\n%s wird uebertragen\n",buf);
	  len = write(orig_sock, buf, BUFSIZ);
	  if (len!=BUFSIZ) ERROR("write");
	  if (!strncmp("quit",buf,4)) 
		{ 
		  close(orig_sock); 
		  exit(0); 
		} 
	  	  

	  if (!strncmp("go",buf,2)) 
		{ 
		  printf("Multiple Package ON!\n");
		  gets(buf);
		  count = 1024 * atoi(buf);
		  memset (buf,0,BUFSIZ);
		  
		  printf("uebertrage %d kb(%d)Mb.\n",count,(int)count/1024);
		  for (i=0;i<count;i++)
			{
			  len = write(orig_sock, buf, BUFSIZ);
			  if (len!=BUFSIZ) ERROR("write");
			  
			}
		  printf("Uebertragung beendet!\n");
		   
		} 
	  
	} while(1);
  
}



