#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#define ERROR(x) { perror(x); exit(1); }
short PORT = 7777;

static char buf[BUFSIZ];

int main(int argc, char *argv[]) {
  int orig_sock, new_sock, clnt_len;
  struct sockaddr_in clnt_adr, serv_adr;
  int len,proc_id,offset,i,j;

 
  
  
  if (argc == 2) 
	{
	  offset = atoi(argv[1]);
	 
	  PORT += offset;
	}
   
  printf ("PORT:%d\n",PORT);
  printf("Die Buffersize betraegt auf diesem System %d\n",BUFSIZ);
  if ((orig_sock = socket(AF_INET,SOCK_STREAM, 0))<0) ERROR("socket");

  memset(&serv_adr, 0, sizeof(serv_adr));
  serv_adr.sin_family = AF_INET;
  
  serv_adr.sin_addr.s_addr = htonl(INADDR_ANY);
  serv_adr.sin_port = htons(PORT);

  if (bind(orig_sock,(struct sockaddr *)&serv_adr,sizeof(serv_adr))<0)
    ERROR("bind");

  if (listen(orig_sock,5) <0) ERROR("listen");

  clnt_len = sizeof(clnt_adr);


  do
	{
	  
	  if ((new_sock = accept(orig_sock,(struct sockaddr *)&clnt_adr,&clnt_len)) < 0) 
		ERROR("accept");
	  proc_id = fork();
	  if (proc_id==0) break;
	  else
	    printf("Sohnprozess %d erstellt\n",proc_id);
	  
	    
	  
 	}
  while (1);


  printf("Connection established!\n");
  i=1;
  do {
    memset(buf,0,BUFSIZ);
   
  
	if (i==1) 
	  {
		len = read(new_sock, buf, BUFSIZ);
		printf("got msg: %s\n",buf);
		
		
	  }
	else
	  {
		for (j=0;j<1023;j++) 
		  {
			len = read(new_sock, buf, BUFSIZ);
			if (!strncmp("quit",buf,4)) {
			  close(new_sock);
			  close(orig_sock);
			  printf("Completed\n");
			  exit(0);
			}
			if (!strncmp("single",buf,6)) 
			  {
				printf("Switch to Single msgs mode\n");
				i=1;
				break;
			  }
		  }
		printf("1 Mb uebertragen!\n");
	  }

	if (!strncmp("quit",buf,4)) {
	  close(new_sock);
	  close(orig_sock);
	  printf("Completed\n");
	  exit(0);
		}
		
	
	if (!strncmp("go",buf,2)) 
	  {
		printf("Switch to Multiple msgs mode\n");
		i=0;
	  }

	if (!strncmp("single",buf,6)) 
	  {
		printf("Switch to Single msgs mode\n");
		i=1;
	  }



  } while(1);
}
